#include "box.h"
#include "globals.h"

Box::Box()
{
	set(0, 0, 0, 0, 0, 0, 0, 0);
}

Box::~Box()
{
}

void Box::set_color(Uint8 red, Uint8 green, Uint8 blue, Uint8 alpha)
{
	r = red;
	g = green;
	b = blue;
	a = alpha;
}

void Box::set_position(const int n, const int m, const int c, const int d)
{
	setxy(n, m);
	setwh(c, d);
}

void Box::set(const int n, const int m, const int c, const int d, Uint8 red, Uint8 green, Uint8 blue, Uint8 alpha)
{
	set_position(n, m, c, d);
	set_color(red, green, blue, alpha);
}

void Box::draw()
{
	if(!is_visible())
	{
		return;
	}
	boxRGBA(screen, getx(), gety(), getx() + getw(), gety() + geth(), r, g, b, a);
}

void Box::setw(const int n)
{
	w = n;
}

void Box::seth(const int n)
{
	h = n;
}

void Box::setwh(const int n, const int m)
{
	setw(n);
	seth(m);
}

int Box::getw()
{
	return w;
}

int Box::geth()
{
	return h;
}

