#include "bullet.h"

#include <iostream>

using namespace std;

Bullet::Bullet()
{
}

Bullet::Bullet(const char *path, const int s)
{
	init(path, s);
}

Bullet::~Bullet()
{
}

void Bullet::init(const char *path, const int s)
{
	Object<bullet_struct>::init(path);
	speed = s;
}

int Bullet::collision(Enemy &a)
{
	object_struct *bullet, *next;
	int retval = 0;
	for(bullet = next_object(NULL); bullet != NULL; bullet = next)
	{
		next = next_object(bullet);
		if(a.collision(bullet->sprite))
		{
			retval++;
			del_object(bullet);
		}
	}
	return retval;
}

void Bullet::add(const int x, const int y)
{
	object_struct *bullet;
	if((bullet = add_object(x, y, speed, 0)) == NULL)
	{
		return;
	}
	bullet->sprite.set_frame(rand());
}

void Bullet::add(Sprite &a, const int xoffset, const int yoffset)
{
	add((int)a.getx() + (a.getw() / 2) + xoffset, (int)a.gety() + (a.geth() / 2) + yoffset);
}

void Bullet::add(Sprite &a)
{
	add(a, 0, 0);
}

bool Bullet::alive()
{
	if(next_object(NULL) == NULL)
	{
		return false;
	}
	return true;
}


