#include "enemy.h"

#include <iostream>

using namespace std;

Enemy::Enemy()
{
}

Enemy::Enemy(const char *path, const int h)
{
	init(path, h);
}

Enemy::Enemy(const char *path, const char *effect_path, const int h)
{
	init(path, effect_path, h);
}

Enemy::~Enemy()
{
}

void Enemy::init(const char *path, const int h)
{
	Object<enemy_struct>::init(path);
	health = h;
	no_effect = true;
}

void Enemy::init(const char *path, const char *effect_path, const int h)
{ 
	Object<enemy_struct>::init(path);
	try
	{
		effect.init(effect_path);
	}
	catch(...)
	{
		reset();
		throw;
	}
	no_effect = false;
	health = h;
}

void Enemy::move()
{
	Object<enemy_struct>::move();
	effect.move();
}

void Enemy::draw()
{
	Object<enemy_struct>::draw();
	effect.draw();
}

bool Enemy::hard_collision(Sprite &a)
{
	object_struct *enemy;
	
	if((enemy = object_collision(a)) != NULL)
	{
		del(enemy);
		return true;
	}
	return false;
}

bool Enemy::collision(Sprite &a)
{
	object_struct *enemy;
	if((enemy = object_collision(a)) != NULL)
	{
		enemy->data.health--;
		if(enemy->data.health <= 0)
		{
			del(enemy);
		}
		return true;
	}
	return false;
}

bool Enemy::del(object_struct *enemy)
{
	effect.add((int)enemy->sprite.getx() + (getw() / 2) - (effect.getw() / 2), (int)enemy->sprite.gety() + (geth() / 2) - (effect.geth() / 2));
	return del_object(enemy);
}

void Enemy::add(int y, int speed)
{
	object_struct *enemy;
	speed++;
	if((enemy = add_object(640, y, speed, 0)) == NULL)
	{
		return;
	}
	
	enemy->sprite.set_frame(rand());
	enemy->data.health = health;
}

