#ifndef FONT_H
#define FONT_H

extern "C"
{
#include <SDL.h>
#include <SDL_ttf.h>
}

#include "xy.h"
#include "visible.h"

class BFont
{
	public:
		BFont();
		BFont(const char *, const int, const bool = false, const bool = false, const bool = false);
		~BFont();
		void init(const char *, const int, const bool = false, const bool = false, const bool = false);
		SDL_Surface *render_text(const char *, Uint8, Uint8, Uint8);
		bool is_init_done();
	private:
		TTF_Font *font;
		bool init_done;
};

class Font : public XY<int>, public Visible
{
	public:
		Font();
		Font(const char *, const int);
		Font(BFont &);
		~Font();
		void init(const char *, const int);
		void init(BFont &);
		void draw();
		void draw_justified();
		void draw_vcentered();
		void draw_hcentered();
		void draw_centered();
		bool render_text(const char *, Uint8, Uint8, Uint8);
		int getw();
		int geth();
	private:
		SDL_Surface *text;
		BFont *base;
		bool our_base;
};


#endif





