#include "image.h"
#include "features.h"

Image::Image() : image(NULL)
{
}

Image::Image(const char *filename) : image(NULL)
{
	load(filename);
}

Image::Image(const char *filename, Uint8 r, Uint8 g, Uint8 b) : image(NULL)
{
	load(filename, r, g, b);
}

Image::~Image()
{
	free_img(image);
}

void Image::load(const char *filename)
{
	free_img(image);
	image = load_img(filename);
}

void Image::load(const char *filename, Uint8 r, Uint8 g, Uint8 b)
{
	free_img(image);
	image = load_img(filename, r, g, b);
}

void Image::draw()
{
	if(!is_visible())
	{
		return;
	}
	draw_img(image, getx(), gety());
}

void Image::draw_pice(const int a, const int b, const int c, const int d)
{
	if(!is_visible())
	{
		return;
	}
	draw_img(image, getx(), gety(), a, b, c, d);
}

int Image::getw()
{
	if(image == NULL)
	{
		return 0;
	}
	return image->w;
}

int Image::geth()
{
	if(image == NULL)
	{
		return 0;
	}
	return image->h;
}


