#ifndef SPACERIDER_H
#define SPACERIDER_H

extern "C"
{
#include <SDL.h>
#include <SDL_thread.h>
}

#include "sprite.h"
#include "enemy.h"
#include "bullet.h"
#include "image.h"
#include "font.h"
#include "music.h"
#include "box.h"


class Spacerider
{
	public:
		Spacerider(const int, char *[]);
		~Spacerider();
		void loop();

	private:
		void shoot();
		void add_enemy(Enemy &);
		void draw_frame();
		void draw_scroll();
		void init_screen();
		void parse_events();
		void send_score();
		void draw_highscore();
		friend int send_score_thread(void *);

		bool fullscreen, game_over, online_highscore, score_sent, name_input, highscore_thread_started;
		float scroll;
		Uint32 dtime, last_enemy;

		Sprite ship;
		Bullet rocket;
		Enemy brain_monster, star_monster1, star_monster2;
		Image logo, logo2, background;
		
		BFont digital_big, digital_small, standard_big, standard_small, dots;
		Font info_txt, info_txt2, version_string, fps_string, lives_string, score_string, pause_string, game_over_string, game_over_txt, name_string, name_input_txt;

		Music music;
		Box highscore_box1, highscore_box2, highscore_box3, name_box1, name_box2, cursor;
		SDL_Thread *highscore_thread;
		
		int score, lives, fps;
		char name[16];
		struct
		{
			Font score;
			Font name;
			Font position;
		} highscore[6];
};


#endif

